#ifndef CharChain_H
#define CharChain_H

class CharChain
{
	public:
		enum CharChainExceptions { IndexError, WrongLength, Circle };

		CharChain();
		virtual ~CharChain();

		int length() const;

		void write() const;
		void upload();

		void append(CharChain &other);

		void subchainDeleting(int first, int length);

		CharChain& operator=(const CharChain &right);
		CharChain(const CharChain &other);

    private:
		
};

#endif
