#include <string>
#include <iostream>

#include "charchain.h"

using namespace std;

int main()
{
	// 1 pontért (constructor, destructor, length)

    cout << endl << " 1 pontert: (constructor, destructor, length)" << endl << endl;

    CharChain *k0;
    k0 = new CharChain();
    cout << "Ures karakterlanc hossza: " << k0->length() << endl;
    delete k0;

    cout << endl << " ********* " << endl;


	// 2 pontért (upload, write)

    cout << endl << " 2 pontert: (upload, write)" << endl << endl;

    CharChain k1;
    cout << "Adjon meg egy karakterlancot: ";
    k1.upload();
	cout << "A feltoltott karakterlanc: ";
	cout << "<"; k1.write(); cout << ">";
	cout << " hossza: "  << k1.length() << endl;
    cout << endl; cout << endl;

	CharChain k2;
	cout << "Adjon meg egy masik karakterlancot: ";
	k2.upload();
	cout << "A feltoltott karakterlanc: ";
	cout << "<"; k2.write(); cout << ">";
	cout << " hossza: "  << k2.length() << endl << endl;

    cout << "Adja meg ujra a masodik karakterlancot: ";
	k2.upload();
	cout << "A feltoltott karakterlanc: ";
	cout << "<"; k2.write(); cout << ">";
	cout << " hossza: "  << k2.length() << endl;

    cout << endl << " ********* " << endl;


	// 3 pontért (Hozzafuz)

    cout << endl << " 3 pontert: (append)" << endl << endl;

	k1.append(k2);
    cout << "Az elso lanchoz fuzzuk a masodikat: ";
    cout << "<"; k1.write(); cout << ">";
    cout << " hossza: " << k1.length() << endl;
    cout << "Masodik karakterlanc: ";
    cout << "<"; k2.write(); cout << ">";
    cout << " hossza: " << k2.length() << endl;

    CharChain k3;
    k1.append(k3);
    cout << "Ures lancot fuzunk az elobb osszefuzott lanchoz: ";
    cout << "<"; k1.write(); cout << ">";
    cout << " hossza: "  << k1.length() << endl;

    k2.append(k3);
    cout << "Ures lancot fuzunk ures lanchoz: ";
    cout << "<"; k3.write(); cout << ">";
    cout << " hossza: "  << k3.length() << endl;

    try {
        cout << "k1.append(k1)\n";
        k1.append(k1);
	}catch (CharChain::CharChainExceptions k){
	    if(k==CharChain::Circle) cout << "nem fuzhetjuk onmaga utan" << endl;
	}

    cout << endl << " ********* " << endl;


	// 4 pontért (subchainDeleting)

	cout << endl << " 4 pontert: (subchainDeleting)" << endl << endl;

	cout << "Az osszefuzott karakterlanc: ";
	cout << "<"; k1.write(); cout << ">" << endl;

    try
	{
        cout << "torol a 2-tol kezdve 4 darabot: " ;
        k1.subchainDeleting(2, 4);
        cout << "<"; k1.write(); cout << ">" << endl;
    }
	catch (CharChain::CharChainExceptions k)
	{
		if(k==CharChain::IndexError) cout << "index hiba" << endl;
		else if(k==CharChain::WrongLength) cout << "hossz hiba" << endl;
	}

    try
	{
        cout << "\ntorol a 1-tol kezdve -4 darabot: ";
        k1.subchainDeleting(1, -4);
    }
	catch (CharChain::CharChainExceptions k)
	{
		if(k==CharChain::IndexError) cout << "index hiba" << endl;
		else if(k==CharChain::WrongLength) cout << "hossz hiba" << endl;
	}

	try
	{
		cout << "torol a 0-tol kezdve -1 darabot: " ;
		k1.subchainDeleting(0,-1);
	}
	catch (CharChain::CharChainExceptions k)
	{
		if(k==CharChain::IndexError) cout << "index hiba" << endl;
		else if(k==CharChain::WrongLength) cout << "hossz hiba" << endl;
	}

    try
	{
        cout << "torol az 1-tol kezdve 0 darabot: " ;
        k1.subchainDeleting(1,0);
	}
	catch (CharChain::CharChainExceptions k)
	{
		if(k==CharChain::IndexError) cout << "index hiba" << endl;
		else if(k==CharChain::WrongLength) cout << "hossz hiba" << endl;
	}


    try
	{
        CharChain k4;
        cout << "\nAdjon meg egy karakterlancot: ";
        k4.upload();
        cout << "A feltoltott karakterlanc: ";
        cout << "<"; k4.write(); cout << ">" << endl;
        cout << "torol a 1-tol kezdve 100 darabot: " ;
        k4.subchainDeleting(1, 100);
        cout << "<"; k4.write(); cout << ">" << endl;
    }
	catch (CharChain::CharChainExceptions k)
	{
		if(k==CharChain::IndexError) cout << "index hiba" << endl;
		else if(k==CharChain::WrongLength) cout << "hossz hiba" << endl;
	}


    cout << "karakterlanc nem valtozott: ";
    cout << "<"; k1.write(); cout << ">" << endl;

    cout << endl << " ********* " << endl;


	// 5 pontért (copy consructor, assign)

    cout << endl << " 5 pontert: (copy consructor, assign operator)" << endl << endl;

    CharChain ka;
    cout << "k1 karakterlanc: ";
    cout << "<"; k1.write(); cout << ">" << endl;
    cout << "k2 karakterlanc: ";
    cout << "<"; k2.write(); cout << ">" << endl;

    cout << "\nk1 = k1" << endl;
    k1 = k1;
    cout << "k1 karakterlanc: ";
    cout << "<"; k1.write(); cout << ">" << endl;
    cout << "k2 karakterlanc: ";
    cout << "<"; k2.write(); cout << ">" << endl;

    cout << "\nk2 = k1" << endl;
    k2 = k1;
    cout << "k1 karakterlanc: ";
    cout << "<"; k1.write(); cout << ">" << endl;
    cout << "k2 karakterlanc: ";
    cout << "<"; k2.write(); cout << ">" << endl;


    cout << "\nk2.subchainDeleting(1,1)" << endl;
    k2.subchainDeleting(1,1);
    cout << "k1 karakterlanc: ";
    cout << "<"; k1.write(); cout << ">" << endl;
    cout << "k2 karakterlanc: ";
    cout << "<"; k2.write(); cout << ">" << endl;


    cout << "\nk3 = k2 = k1 " << endl;
    k3 = k2 = k1;
    cout << "k3 karakterlanc: ";
    cout << "<"; k3.write(); cout << ">" << endl;
    cout << "k2 karakterlanc: ";
    cout << "<"; k2.write(); cout << ">" << endl;
    cout << "k1 karakterlanc: ";
    cout << "<"; k1.write(); cout << ">" << endl;

    cout << endl << " ********* " << endl;

	return 0;
}

